from .chunk_readers import readAttachment, readBindPose, readBone, readCollisionShape, readDynamicChunk, readEvent, readFaceFX, readGeoset, readGeosetAnimation, readGlobalSequences, readHelper, readMaterial, readModelHeader, readPivotData, readSequences, readTextures, readVersion
from ..importer import importer
from ..classes.MdxParts import WarCraft3Model
from .. import constants

from ..properties import MDXImportProperties
from .binary_reader import StreamReader





def load_mdx(import_properties: MDXImportProperties):
    #mdx_file = open(import_properties.mdx_file_path, 'rb')
    #mdx_file_data = mdx_file.read()
    #mdx_file.close()
    #parse_mdx(mdx_file_data, import_properties)
    print("NO SHIT!")

    with open(import_properties.mdx_file_path, 'rb') as f:
        r:StreamReader = StreamReader(f)
        tag = r.read4cc()
        if tag==constants.CHUNK_MDX_MODEL:
            print("model read start")
            lookup = {
                constants.CHUNK_VERSION : readVersion,
                constants.CHUNK_MODEL : readModelHeader,
                constants.CHUNK_TEXTURE : readTextures,
                constants.CHUNK_MODEL : readModelHeader,
                constants.CHUNK_PIVOT_POINT : readPivotData,
                constants.CHUNK_FACE_EFFECT : readFaceFX,
                constants.CHUNK_BIND_POSE : readBindPose,
                constants.CHUNK_SEQUENCE : readSequences,
                constants.CHUNK_GLOBAL_SEQUENCE : readGlobalSequences

            }
            model:WarCraft3Model = WarCraft3Model()
            model.file = import_properties.mdx_file_path
            while True:
                tag = r.read4cc()
                if tag:
                    print("chunk: "+tag)
                    rdr = lookup.get(tag,None)
                    if rdr:
                        rdr(r,model)
                    elif tag == constants.CHUNK_GEOSET:
                        readDynamicChunk(r, model, readGeoset)
                    elif tag == constants.CHUNK_BONE:
                        readDynamicChunk(r, model, readBone)
                    elif tag == constants.CHUNK_MATERIAL:
                        readDynamicChunk(r, model, readMaterial)
                    elif tag == constants.CHUNK_HELPER:
                        readDynamicChunk(r, model, readHelper)
                    elif tag == constants.CHUNK_ATTACHMENT:
                        readDynamicChunk(r, model, readAttachment)
                    elif tag == constants.CHUNK_EVENT_OBJECT:
                        readDynamicChunk(r, model, readEvent)
                    elif tag == constants.CHUNK_COLLISION_SHAPE:
                        readDynamicChunk(r, model, readCollisionShape)
                    elif tag == constants.CHUNK_GEOSET_ANIMATION:
                        readDynamicChunk(r, model, readGeosetAnimation)
                    else:
                        size = r.readInt()
                        r.skip(size)
                        print(("unknown chunk "+tag+" of size {}").format(size))
                else:
                    break
            importer.load_warcraft_to_ue_model(model, import_properties)
        
