import bpy
import importlib
from . import (
    binary_reader,
    chunk_readers,
    get_vertex_groups,
    load_mdx
    
)


submodules = [
    binary_reader,
    chunk_readers,
    get_vertex_groups,
    load_mdx
]

classes = [
    #binary_reader.Reader,
    #binary_reader.StreamReader
]

def register():
    for module in submodules:
        importlib.reload(module)

    for cls in classes:
        bpy.utils.register_class(cls)

def unregister():
    for cls in reversed(classes):
        bpy.utils.unregister_class(cls)